/* CSSView.c generated by valac 0.40.19, the Vala compiler
 * generated from CSSView.vala, do not modify */

/*-
 * Copyright (c) 2017 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "granite.h"
#include <float.h>
#include <math.h>


#define TYPE_CSS_VIEW (css_view_get_type ())
#define CSS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CSS_VIEW, CSSView))
#define CSS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CSS_VIEW, CSSViewClass))
#define IS_CSS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CSS_VIEW))
#define IS_CSS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CSS_VIEW))
#define CSS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CSS_VIEW, CSSViewClass))

typedef struct _CSSView CSSView;
typedef struct _CSSViewClass CSSViewClass;
typedef struct _CSSViewPrivate CSSViewPrivate;
enum  {
	CSS_VIEW_0_PROPERTY,
	CSS_VIEW_WINDOW_PROPERTY,
	CSS_VIEW_NUM_PROPERTIES
};
static GParamSpec* css_view_properties[CSS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;

struct _CSSView {
	GtkGrid parent_instance;
	CSSViewPrivate * priv;
};

struct _CSSViewClass {
	GtkGridClass parent_class;
};

struct _CSSViewPrivate {
	GtkWindow* _window;
};

struct _Block5Data {
	int _ref_count_;
	CSSView* self;
	GtkColorButton* primary_color_button;
};


static gpointer css_view_parent_class = NULL;

GType css_view_get_type (void) G_GNUC_CONST;
#define CSS_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CSS_VIEW, CSSViewPrivate))
CSSView* css_view_new (GtkWindow* window);
CSSView* css_view_construct (GType object_type,
                             GtkWindow* window);
GtkWindow* css_view_get_window (CSSView* self);
static void css_view_set_window (CSSView* self,
                          GtkWindow* value);
static GObject * css_view_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _css_view___lambda5_ (Block5Data* _data5_);
static void __css_view___lambda5__gtk_color_button_color_set (GtkColorButton* _sender,
                                                       gpointer self);
static void css_view_finalize (GObject * obj);
static void _vala_css_view_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_css_view_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);


CSSView*
css_view_construct (GType object_type,
                    GtkWindow* window)
{
	CSSView * self = NULL;
	g_return_val_if_fail (window != NULL, NULL);
	self = (CSSView*) g_object_new (object_type, "halign", GTK_ALIGN_CENTER, "valign", GTK_ALIGN_CENTER, "margin", 24, "window", window, NULL);
	return self;
}


CSSView*
css_view_new (GtkWindow* window)
{
	return css_view_construct (TYPE_CSS_VIEW, window);
}


GtkWindow*
css_view_get_window (CSSView* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_window;
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
css_view_set_window (CSSView* self,
                     GtkWindow* value)
{
	g_return_if_fail (self != NULL);
	if (css_view_get_window (self) != value) {
		GtkWindow* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_window);
		self->priv->_window = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, css_view_properties[CSS_VIEW_WINDOW_PROPERTY]);
	}
}


static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		CSSView* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->primary_color_button);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}


static void
_css_view___lambda5_ (Block5Data* _data5_)
{
	CSSView* self;
	GtkWindow* _tmp0_;
	GtkColorButton* _tmp1_;
	GdkRGBA _tmp2_ = {0};
	GdkRGBA _tmp3_;
	GtkCssProvider* _tmp4_;
	GtkCssProvider* _tmp5_;
	self = _data5_->self;
	_tmp0_ = self->priv->_window;
	_tmp1_ = _data5_->primary_color_button;
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp1_, &_tmp2_);
	_tmp3_ = _tmp2_;
	_tmp4_ = granite_widgets_utils_set_color_primary ((GtkWidget*) _tmp0_, &_tmp3_, GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp5_);
}


static void
__css_view___lambda5__gtk_color_button_color_set (GtkColorButton* _sender,
                                                  gpointer self)
{
	_css_view___lambda5_ (self);
}


static GObject *
css_view_constructor (GType type,
                      guint n_construct_properties,
                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CSSView * self;
	Block5Data* _data5_;
	GtkLabel* header1 = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkLabel* header2 = NULL;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkLabel* header3 = NULL;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkLabel* header4 = NULL;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkLabel* card_label = NULL;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkGrid* card = NULL;
	GtkGrid* _tmp18_;
	GtkGrid* _tmp19_;
	GtkStyleContext* card_context = NULL;
	GtkGrid* _tmp20_;
	GtkStyleContext* _tmp21_;
	GtkStyleContext* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkGrid* _tmp24_;
	GtkLabel* _tmp25_;
	GtkGrid* _tmp26_;
	GtkLabel* _tmp27_;
	GtkGrid* _tmp28_;
	GtkLabel* _tmp29_;
	GtkGrid* _tmp30_;
	GtkLabel* _tmp31_;
	GtkLabel* checker_label = NULL;
	GtkLabel* _tmp32_;
	GtkImage* checker_image = NULL;
	GtkImage* _tmp33_;
	GtkImage* _tmp34_;
	GtkImage* _tmp35_;
	GtkGrid* checker_grid = NULL;
	GtkGrid* _tmp36_;
	GtkGrid* _tmp37_;
	GtkStyleContext* _tmp38_;
	GtkGrid* _tmp39_;
	GtkImage* _tmp40_;
	GtkLabel* terminal_label = NULL;
	GtkLabel* _tmp41_;
	GtkTextView* terminal = NULL;
	GtkTextView* _tmp42_;
	GtkTextView* _tmp43_;
	GtkTextBuffer* _tmp44_;
	GtkTextBuffer* _tmp45_;
	GtkTextView* _tmp46_;
	GtkTextView* _tmp47_;
	GtkTextView* _tmp48_;
	GtkStyleContext* _tmp49_;
	GtkLabel* back_button_label = NULL;
	GtkLabel* _tmp50_;
	GtkLabel* _tmp51_;
	GtkButton* back_button = NULL;
	GtkButton* _tmp52_;
	GtkButton* _tmp53_;
	GtkButton* _tmp54_;
	GtkStyleContext* _tmp55_;
	GtkLabel* primary_color_label = NULL;
	GtkLabel* _tmp56_;
	GtkLabel* _tmp57_;
	GdkRGBA _tmp58_ = {0};
	GtkColorButton* _tmp59_;
	GtkLabel* accent_color_label = NULL;
	GtkLabel* _tmp60_;
	GtkLabel* _tmp61_;
	GtkImage* accent_color_icon = NULL;
	GtkImage* _tmp62_;
	GtkImage* _tmp63_;
	GtkStyleContext* _tmp64_;
	GtkLabel* accent_color_string = NULL;
	GtkLabel* _tmp65_;
	GtkLabel* _tmp66_;
	GtkStyleContext* _tmp67_;
	GtkGrid* accent_color_grid = NULL;
	GtkGrid* _tmp68_;
	GtkGrid* _tmp69_;
	GtkGrid* _tmp70_;
	GtkImage* _tmp71_;
	GtkGrid* _tmp72_;
	GtkLabel* _tmp73_;
	GtkLabel* _tmp74_;
	GtkGrid* _tmp75_;
	GtkLabel* _tmp76_;
	GtkGrid* _tmp77_;
	GtkLabel* _tmp78_;
	GtkTextView* _tmp79_;
	GtkLabel* _tmp80_;
	GtkButton* _tmp81_;
	GtkLabel* _tmp82_;
	GtkColorButton* _tmp83_;
	GtkLabel* _tmp84_;
	GtkGrid* _tmp85_;
	GtkColorButton* _tmp86_;
	parent_class = G_OBJECT_CLASS (css_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CSS_VIEW, CSSView);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	_tmp0_ = (GtkLabel*) gtk_label_new ("\"h1\" Style Class");
	g_object_ref_sink (_tmp0_);
	header1 = _tmp0_;
	_tmp1_ = header1;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp1_, 12);
	_tmp2_ = header1;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp2_, 24);
	_tmp3_ = header1;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp3_, 24);
	_tmp4_ = header1;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_add_class (_tmp5_, GRANITE_STYLE_CLASS_H1_LABEL);
	_tmp6_ = (GtkLabel*) gtk_label_new ("\"h2\" Style Class");
	g_object_ref_sink (_tmp6_);
	header2 = _tmp6_;
	_tmp7_ = header2;
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
	gtk_style_context_add_class (_tmp8_, GRANITE_STYLE_CLASS_H2_LABEL);
	_tmp9_ = (GtkLabel*) gtk_label_new ("\"h3\" Style Class");
	g_object_ref_sink (_tmp9_);
	header3 = _tmp9_;
	_tmp10_ = header3;
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
	gtk_style_context_add_class (_tmp11_, GRANITE_STYLE_CLASS_H3_LABEL);
	_tmp12_ = (GtkLabel*) gtk_label_new ("\"h4\" Style Class");
	g_object_ref_sink (_tmp12_);
	header4 = _tmp12_;
	_tmp13_ = header4;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp13_, 12);
	_tmp14_ = header4;
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
	gtk_style_context_add_class (_tmp15_, GRANITE_STYLE_CLASS_H4_LABEL);
	_tmp16_ = (GtkLabel*) gtk_label_new ("\"card\" with \"rounded\" style class:");
	g_object_ref_sink (_tmp16_);
	card_label = _tmp16_;
	_tmp17_ = card_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp17_, GTK_ALIGN_END);
	_tmp18_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp18_);
	card = _tmp18_;
	_tmp19_ = card;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp19_, GTK_ORIENTATION_VERTICAL);
	_tmp20_ = card;
	_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) _tmp20_);
	card_context = _tmp21_;
	_tmp22_ = card_context;
	gtk_style_context_add_class (_tmp22_, GRANITE_STYLE_CLASS_CARD);
	_tmp23_ = card_context;
	gtk_style_context_add_class (_tmp23_, GRANITE_STYLE_CLASS_ROUNDED);
	_tmp24_ = card;
	_tmp25_ = header1;
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
	_tmp26_ = card;
	_tmp27_ = header2;
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
	_tmp28_ = card;
	_tmp29_ = header3;
	gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
	_tmp30_ = card;
	_tmp31_ = header4;
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
	_tmp32_ = (GtkLabel*) gtk_label_new ("\"checkerboard\" style class:");
	g_object_ref_sink (_tmp32_);
	checker_label = _tmp32_;
	_tmp33_ = (GtkImage*) gtk_image_new_from_icon_name ("dialog-information", (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp33_);
	checker_image = _tmp33_;
	_tmp34_ = checker_image;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp34_, TRUE);
	_tmp35_ = checker_image;
	g_object_set ((GtkWidget*) _tmp35_, "margin", 6, NULL);
	_tmp36_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp36_);
	checker_grid = _tmp36_;
	_tmp37_ = checker_grid;
	_tmp38_ = gtk_widget_get_style_context ((GtkWidget*) _tmp37_);
	gtk_style_context_add_class (_tmp38_, GRANITE_STYLE_CLASS_CHECKERBOARD);
	_tmp39_ = checker_grid;
	_tmp40_ = checker_image;
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
	_tmp41_ = (GtkLabel*) gtk_label_new ("\"terminal\" style class:");
	g_object_ref_sink (_tmp41_);
	terminal_label = _tmp41_;
	_tmp42_ = (GtkTextView*) gtk_text_view_new ();
	g_object_ref_sink (_tmp42_);
	terminal = _tmp42_;
	_tmp43_ = terminal;
	_tmp44_ = gtk_text_view_get_buffer (_tmp43_);
	_tmp45_ = _tmp44_;
	g_object_set (_tmp45_, "text", "[ 73%] Linking C executable granite-demo\n" \
"[100%] Built target granite-demo", NULL);
	_tmp46_ = terminal;
	gtk_text_view_set_pixels_below_lines (_tmp46_, 3);
	_tmp47_ = terminal;
	gtk_container_set_border_width ((GtkContainer*) _tmp47_, (guint) 12);
	_tmp48_ = terminal;
	_tmp49_ = gtk_widget_get_style_context ((GtkWidget*) _tmp48_);
	gtk_style_context_add_class (_tmp49_, GRANITE_STYLE_CLASS_TERMINAL);
	_tmp50_ = (GtkLabel*) gtk_label_new ("\"back-button\" style class:");
	g_object_ref_sink (_tmp50_);
	back_button_label = _tmp50_;
	_tmp51_ = back_button_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp51_, GTK_ALIGN_END);
	_tmp52_ = (GtkButton*) gtk_button_new_with_label ("Back Button");
	g_object_ref_sink (_tmp52_);
	back_button = _tmp52_;
	_tmp53_ = back_button;
	gtk_widget_set_halign ((GtkWidget*) _tmp53_, GTK_ALIGN_START);
	_tmp54_ = back_button;
	_tmp55_ = gtk_widget_get_style_context ((GtkWidget*) _tmp54_);
	gtk_style_context_add_class (_tmp55_, GRANITE_STYLE_CLASS_BACK_BUTTON);
	_tmp56_ = (GtkLabel*) gtk_label_new ("Set HeaderBar color:");
	g_object_ref_sink (_tmp56_);
	primary_color_label = _tmp56_;
	_tmp57_ = primary_color_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp57_, GTK_ALIGN_END);
	_tmp58_.red = (gdouble) 222;
	_tmp58_.green = (gdouble) 222;
	_tmp58_.blue = (gdouble) 222;
	_tmp58_.alpha = (gdouble) 255;
	_tmp59_ = (GtkColorButton*) gtk_color_button_new_with_rgba (&_tmp58_);
	g_object_ref_sink (_tmp59_);
	_data5_->primary_color_button = _tmp59_;
	_tmp60_ = (GtkLabel*) gtk_label_new ("Accent colored labels and icons:");
	g_object_ref_sink (_tmp60_);
	accent_color_label = _tmp60_;
	_tmp61_ = accent_color_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp61_, GTK_ALIGN_END);
	_tmp62_ = (GtkImage*) gtk_image_new_from_icon_name ("emoji-body-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp62_);
	accent_color_icon = _tmp62_;
	_tmp63_ = accent_color_icon;
	_tmp64_ = gtk_widget_get_style_context ((GtkWidget*) _tmp63_);
	gtk_style_context_add_class (_tmp64_, GRANITE_STYLE_CLASS_ACCENT);
	_tmp65_ = (GtkLabel*) gtk_label_new ("Lorem ipsum dolor sit amet");
	g_object_ref_sink (_tmp65_);
	accent_color_string = _tmp65_;
	_tmp66_ = accent_color_string;
	_tmp67_ = gtk_widget_get_style_context ((GtkWidget*) _tmp66_);
	gtk_style_context_add_class (_tmp67_, GRANITE_STYLE_CLASS_ACCENT);
	_tmp68_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp68_);
	accent_color_grid = _tmp68_;
	_tmp69_ = accent_color_grid;
	gtk_grid_set_column_spacing (_tmp69_, 6);
	_tmp70_ = accent_color_grid;
	_tmp71_ = accent_color_icon;
	gtk_container_add ((GtkContainer*) _tmp70_, (GtkWidget*) _tmp71_);
	_tmp72_ = accent_color_grid;
	_tmp73_ = accent_color_string;
	gtk_container_add ((GtkContainer*) _tmp72_, (GtkWidget*) _tmp73_);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 24);
	_tmp74_ = card_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp74_, 0, 0, 1, 1);
	_tmp75_ = card;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp75_, 1, 0, 2, 1);
	_tmp76_ = checker_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp76_, 0, 1, 1, 1);
	_tmp77_ = checker_grid;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp77_, 1, 1, 2, 1);
	_tmp78_ = terminal_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp78_, 0, 2, 1, 1);
	_tmp79_ = terminal;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp79_, 1, 2, 2, 1);
	_tmp80_ = back_button_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp80_, 0, 3, 1, 1);
	_tmp81_ = back_button;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp81_, 1, 3, 2, 1);
	_tmp82_ = primary_color_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp82_, 0, 4, 1, 1);
	_tmp83_ = _data5_->primary_color_button;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp83_, 1, 4, 2, 1);
	_tmp84_ = accent_color_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp84_, 0, 5, 1, 1);
	_tmp85_ = accent_color_grid;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp85_, 1, 5, 1, 1);
	_tmp86_ = _data5_->primary_color_button;
	g_signal_connect_data (_tmp86_, "color-set", (GCallback) __css_view___lambda5__gtk_color_button_color_set, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	_g_object_unref0 (accent_color_grid);
	_g_object_unref0 (accent_color_string);
	_g_object_unref0 (accent_color_icon);
	_g_object_unref0 (accent_color_label);
	_g_object_unref0 (primary_color_label);
	_g_object_unref0 (back_button);
	_g_object_unref0 (back_button_label);
	_g_object_unref0 (terminal);
	_g_object_unref0 (terminal_label);
	_g_object_unref0 (checker_grid);
	_g_object_unref0 (checker_image);
	_g_object_unref0 (checker_label);
	_g_object_unref0 (card);
	_g_object_unref0 (card_label);
	_g_object_unref0 (header4);
	_g_object_unref0 (header3);
	_g_object_unref0 (header2);
	_g_object_unref0 (header1);
	block5_data_unref (_data5_);
	_data5_ = NULL;
	return obj;
}


static void
css_view_class_init (CSSViewClass * klass)
{
	css_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CSSViewPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_css_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_css_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = css_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = css_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CSS_VIEW_WINDOW_PROPERTY, css_view_properties[CSS_VIEW_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void
css_view_instance_init (CSSView * self)
{
	self->priv = CSS_VIEW_GET_PRIVATE (self);
}


static void
css_view_finalize (GObject * obj)
{
	CSSView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CSS_VIEW, CSSView);
	_g_object_unref0 (self->priv->_window);
	G_OBJECT_CLASS (css_view_parent_class)->finalize (obj);
}


GType
css_view_get_type (void)
{
	static volatile gsize css_view_type_id__volatile = 0;
	if (g_once_init_enter (&css_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CSSViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) css_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CSSView), 0, (GInstanceInitFunc) css_view_instance_init, NULL };
		GType css_view_type_id;
		css_view_type_id = g_type_register_static (gtk_grid_get_type (), "CSSView", &g_define_type_info, 0);
		g_once_init_leave (&css_view_type_id__volatile, css_view_type_id);
	}
	return css_view_type_id__volatile;
}


static void
_vala_css_view_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	CSSView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CSS_VIEW, CSSView);
	switch (property_id) {
		case CSS_VIEW_WINDOW_PROPERTY:
		g_value_set_object (value, css_view_get_window (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_css_view_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	CSSView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CSS_VIEW, CSSView);
	switch (property_id) {
		case CSS_VIEW_WINDOW_PROPERTY:
		css_view_set_window (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



